structure LambdaCalculusParser =
struct
  structure Arg =
  struct
    type string = string
    
    open LambdaCalculus

    datatype terminal = datatype LambdaCalculusLexer.token

    fun id_exp x = x

    fun error s =
      case Stream.front s of
        Stream.Nil => (print "Syntax error at end of file.\n"; Fail "parse")
    | Stream.Cons ((_, pos), _) =>
        (print "Syntax error at "; print (Int.toString pos); print ".\n"; Fail "parse")
  end

  type pos = int

  structure StreamWithPos =
     CoercedStreamable (structure Streamable = StreamStreamable
                        type 'a item = 'a * pos
                        fun coerce (x, _) = x)

  structure ParseMain = LambdaCalculusParseFun (
    structure Streamable = StreamWithPos
    structure Arg = Arg
  )

  val parse =
    #1 o ParseMain.parse o LambdaCalculusLexer.lex o Stream.fromString
end
