structure LambdaPlusPlusParser =
struct
  structure Arg =
  struct
    type string = string
    
    open LambdaPlusPlus

    datatype terminal = datatype LambdaPlusPlusLexer.token

    fun id_exp x = x
    val case_ = Case o (fn (a, b, c, d, e) => (a, (b, c), (d, e)))

    fun error s =
      case Stream.front s of
        Stream.Nil => (print "Syntax error at end of file.\n"; Fail "parse")
    | Stream.Cons ((_, pos), _) =>
        (print "Syntax error at "; print (Int.toString pos); print ".\n"; Fail "parse")
  end

  type pos = int

  structure StreamWithPos =
     CoercedStreamable (structure Streamable = StreamStreamable
                        type 'a item = 'a * pos
                        fun coerce (x, _) = x)

  structure ParseMain = LambdaPlusPlusParseFun (
    structure Streamable = StreamWithPos
    structure Arg = Arg
  )

  val parse =
    #1 o ParseMain.parse o LambdaPlusPlusLexer.lex o Stream.fromString
end
